#! /bin/sh

# This script is responsible for creating a date stamp.
# It should be installed in your voice directory once you got
# it working correctly.
#
# Input: a filename, passed as $1
#
# Output: a voice file on STDOUT, e.g. adpcm4
#
# This implementation uses GNU find and the rsynth synthesizer.

AMP=3.5

MSG=`find $1 -printf 'This message was recorded on %TA, %TB %Td, at %Tk %TM.\n'`

say "$MSG" -r 9600 -L -l - \
| lintopvf | pvfcut -0.5 0 | pvfamp $AMP | pvftozyxel4
